Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 1)
+++ CMakeLists.txt	(revision 8)
@@ -3,4 +3,12 @@
 # Name of the project, and language
 PROJECT("freeDiameter" C)
+
+# Informations to display in daemon's help
+SET(FD_PROJECT_NAME freeDiameter)
+SET(FD_PROJECT_BINARY freeDiameterd)
+SET(FD_PROJECT_VERSION_MAJOR 0)
+SET(FD_PROJECT_VERSION_MINOR 1)
+SET(FD_PROJECT_VERSION_REV 0)
+SET(FD_PROJECT_COPYRIGHT "Copyright (c) 2008-2009, WIDE Project (www.wide.ad.jp) and NICT (www.nict.go.jp)")
 
 # Some subfolders may have tests
@@ -16,9 +24,4 @@
 ADD_DEFINITIONS(-D_GNU_SOURCE)
 
-# Location for the include files
-INCLUDE_DIRECTORIES(include)
-INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)
-SUBDIRS(include/freeDiameter)
-
 # some subfolders use yacc and lex parsers
 SET(BISON_GENERATE_DEFINES TRUE)
@@ -33,4 +36,9 @@
 # how to do the check with cmake???
 
+# Location for the include files
+INCLUDE_DIRECTORIES(include)
+INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)
+SUBDIRS(include/freeDiameter)
+
 # Location for the source code
 SUBDIRS(libfreeDiameter)
Index: cmake/Modules/FindSCTP.cmake
===================================================================
--- cmake/Modules/FindSCTP.cmake	(revision 0)
+++ cmake/Modules/FindSCTP.cmake	(revision 8)
@@ -6,24 +6,41 @@
 #  SCTP_LIBRARIES - link these to use SCTP
 
-include(LibFindMacros)
-
-# Use pkg-config to get hints about paths (Note: not yet supported?)
-# libfind_pkg_check_modules(SCTP_PKGCONF sctp)
+if (SCTP_INCLUDE_DIRS)
+  set(SCTP_FIND_QUIETLY TRUE)
+endif (SCTP_INCLUDE_DIRS)
 
 # Include dir
 find_path(SCTP_INCLUDE_DIR
   NAMES netinet/sctp.h
-  PATHS ${SCTP_PKGCONF_INCLUDE_DIRS}
 )
 
-# Finally the library itself
+# Library
 find_library(SCTP_LIBRARY
   NAMES sctp
-  PATHS ${SCTP_PKGCONF_LIBRARY_DIRS}
 )
 
 # Set the include dir variables and the libraries and let libfind_process do the rest.
 # NOTE: Singular variables for this library, plural for libraries this this lib depends on.
-set(SCTP_PROCESS_INCLUDES SCTP_INCLUDE_DIR)
-set(SCTP_PROCESS_LIBS SCTP_LIBRARY)
-libfind_process(SCTP)
+#set(SCTP_PROCESS_INCLUDES SCTP_INCLUDE_DIR)
+#set(SCTP_PROCESS_LIBS SCTP_LIBRARY)
+#libfind_process(SCTP)
+
+
+# handle the QUIETLY and REQUIRED arguments and set SCTP_FOUND to TRUE if
+# all listed variables are TRUE
+INCLUDE(FindPackageHandleStandardArgs)
+FIND_PACKAGE_HANDLE_STANDARD_ARGS(SCTP DEFAULT_MSG SCTP_LIBRARY SCTP_INCLUDE_DIR)
+
+# If we successfully found the sctp library then add the library to the
+# SCTP_LIBRARIES cmake variable otherwise set SCTP_LIBRARIES to nothing.
+IF(SCTP_FOUND)
+   SET( SCTP_LIBRARIES ${SCTP_LIBRARY} )
+ELSE(SCTP_FOUND)
+   SET( SCTP_LIBRARIES )
+ENDIF(SCTP_FOUND)
+
+
+# Lastly make it so that the SCTP_LIBRARY and SCTP_INCLUDE_DIR variables
+# only show up under the advanced options in the gui cmake applications.
+MARK_AS_ADVANCED( SCTP_LIBRARY SCTP_INCLUDE_DIR )
+
Index: doc/freediameter.conf.sample
===================================================================
--- doc/freediameter.conf.sample	(revision 8)
+++ doc/freediameter.conf.sample	(revision 8)
@@ -0,0 +1,132 @@
+# This is a sample configuration file for freeDiameter daemon.
+
+##############################################################
+##  Peer identity and realm 
+
+# The Diameter Identity of this daemon.
+# This must be a valid FQDN that resolves to the local host.
+# Default: hostname's FQDN
+#LocalIdentity = "aaa.koganei.wide.ad.jp";
+
+# The Diameter Realm of this daemon.
+# Default: the domain part of LocalIdentity.
+#LocalRealm = "wide.ad.jp";
+
+##############################################################
+##  Transport protocol configuration
+
+# The port this peer is listening on for incoming connections (TCP and SCTP).
+# Default: 3868
+#LocalPort = 3868;
+
+# The port this peer is listening on for incoming TLS connections (TCP and SCTP).
+# See TLS_old_method for more information.
+# Default: 3869
+#LocalSecPort = 3869;
+
+# Use RFC3588 method for TLS protection, where TLS is negociated after CER/CEA
+# on the same port. This only affects outgoing connections. It can be overwritten
+# on per peer basis.
+# Default: use RFC3588bis method with separate port for TLS.
+#TLS_old_method;
+
+# Disable use of TCP protocol (only SCTP)
+# Default : TCP enabled
+#No_TCP;
+
+# Disable use of SCTP protocol (only TCP)
+# Default : SCTP enabled
+#No_SCTP;
+# This option has no effect if freeDiameter is compiled with DISABLE_SCTP option,
+# in which case the value is forced to "SCTP disabled".
+
+# Prefer TCP over SCTP for establishing new connections.
+# It may be overwritten per peer in peer configuration blocs.
+# Default : SCTP is prefered.
+#Prefer_TCP;
+
+# Default number of streams per SCTP associations.
+# It can be overwritten per peer basis.
+# Default : 30 streams
+#SCTP_streams = 30;
+
+##############################################################
+##  Endpoints configuration
+
+# Disable use of IP addresses (only IPv6)
+# Default : IP enabled
+#No_IP;
+
+# Disable use of IPv6 addresses (only IP)
+# Default : IPv6 enabled
+#No_IPv6;
+
+# Specify local addresses where the server must listen
+# Default : listen on all addresses available.
+#ListenOn = "202.249.37.5";
+#ListenOn = "2001:200:903:2::202:1";
+
+##############################################################
+##  Timers configuration
+
+# The Tc timer of this peer.
+# It is the delay before a new attempt is made to reconnect a disconnected peer.
+# The value is expressed in seconds. The recommended value is 30 seconds.
+# Default: 30
+#TcTimer = 30;
+
+# The Tw timer of this peer.
+# It is the delay before a watchdog message is sent, as described in RFC 3539.
+# The value is expressed in seconds. The default value is 30 seconds. Value must
+# be greater or equal to 6 seconds. See details in the RFC.
+# Default: 30
+#TwTimer = 30;
+
+##############################################################
+##  Applications configuration
+
+# Disable the relaying of Diameter messages?
+# For messages not handled locally, the default behavior is to forward the
+# message to another peer if any is available, according to the routing 
+# algorithms. In addition the "0xffffff" application is advertised in CER/CEA 
+# exchanges.
+# Default: Relaying is enabled.
+#NoRelay;
+
+# Other applications are configured by extensions.
+
+##############################################################
+##  Extensions configuration
+
+#  The freeDiameter daemon merely provides support for
+# Diameter Base Protocol. The specific application behaviors,
+# as well as advanced functions of the daemon, are provided
+# by loadable extensions (plug-ins).
+#  These extensions may in addition receive the name of a 
+# configuration file, the format of which is extension-specific.
+
+# Format:
+#LoadExtension = "/path/to/extension" [ : "/optional/configuration/file" ] ;
+# Exemples:
+#LoadExtension = "extensions/sample.so";
+#LoadExtension = "extensions/sample.so":"conf/sample.conf";
+
+
+
+##############################################################
+# -------- Test configuration ---------
+LocalIdentity = "aaa.koganei.wide.ad.jp";
+LocalRealm = "wide.ad.jp";
+LocalPort = 3866;
+LocalSecPort = 3867;
+TLS_old_method;
+No_IP;
+Prefer_TCP;
+SCTP_streams = 50;
+ListenOn = "202.249.37.5";
+ListenOn = "2001:200:903:2::202:1";
+TcTimer = 60;
+TwTimer = 6;
+NoRelay;
+LoadExtension = "extensions/sample.so";
+LoadExtension = "extensions/sample.so":"conf/sample.conf";
Index: extensions/CMakeLists.txt
===================================================================
--- extensions/CMakeLists.txt	(revision 8)
+++ extensions/CMakeLists.txt	(revision 8)
@@ -0,0 +1,75 @@
+PROJECT("freeDiameter extensions" C)
+
+# We want all resulting objects in the same folder
+SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})
+# And named fdext_XXX instead of libXXX.so
+
+#-- faire une macro ici!
+SET(FD_EXT_PREFIX "fdext_" PARENT_SCOPE)
+SET(FD_EXT_SUFFIX "" PARENT_SCOPE)
+
+###########################
+# Extensions section
+
+####
+# Diameter applications dictionary
+# OPTION(BUILD_DICT_NASREQ "Build NASREQ (RFC4005) Dictionary definitions?" ON)
+# 	IF (BUILD_DICT_NASREQ)
+# 	   SUBDIRS(dict_nasreq)
+# 	ENDIF (BUILD_DICT_NASREQ)
+
+# OPTION(BUILD_DICT_EAP "Build Diameter EAP (RFC4072) Dictionary definitions?" ON)
+# 	IF (BUILD_DICT_EAP)
+# 	   SUBDIRS(dict_eap)
+# 	ENDIF (BUILD_DICT_EAP)
+
+
+
+####
+# Radius / Diameter gateway extension(s)
+# OPTION(BUILD_RADIUS_GW "Build radius_gw? (one-way RADIUS/Diameter gateway - RADIUS NAS <-> Diameter server)" ON)
+# 	IF (BUILD_RADIUS_GW)
+# 	   SUBDIRS(radius_gw)
+# 	ENDIF (BUILD_RADIUS_GW)
+
+
+####
+# Routing extensions
+
+# OPTION(BUILD_RT_DEFAULT "Build rt_default? (Routing extension using Destination-Host, Destination-Realm, and static configuration)" ON)
+# 	IF (BUILD_RT_DEFAULT)
+# 	   SUBDIRS(rt_default)
+# 	ENDIF (BUILD_RT_DEFAULT)
+
+
+####
+# Peers security extensions
+
+# OPTION(BUILD_PS_DEFAULT "Build ps_default? (white-list of peers)" ON)
+# 	IF (BUILD_PS_DEFAULT)
+# # -- enable once API is updated:	   SUBDIRS(ps_default)
+# 	ENDIF (BUILD_PS_DEFAULT)
+
+
+####
+# Debug / development extensions
+
+OPTION(BUILD_SAMPLE "Build sample? (Simple extension to demonstrate extension mechanism, for developpers only)" OFF)
+	IF (BUILD_SAMPLE)
+	   SUBDIRS(_sample)
+	ENDIF (BUILD_SAMPLE)
+
+# OPTION(BUILD_RT_ANY "Build rt_any? (Routing extension sending message to any peer available, for testing purpose only)" OFF)
+# 	IF (BUILD_RT_ANY)
+# 	   SUBDIRS(rt_any)
+# 	ENDIF (BUILD_RT_ANY)
+
+# OPTION(BUILD_RT_DEBUG "Build rt_debug? (Routing extension tracing routing list, for debug purpose only)" OFF)
+# 	IF (BUILD_RT_DEBUG)
+# 	   SUBDIRS(rt_debug)
+# 	ENDIF (BUILD_RT_DEBUG)
+
+# OPTION(BUILD_APP_TEST "Build app_test? (Testing application to send dummy message to another peer, for testing purpose only)" OFF)
+# 	IF (BUILD_APP_TEST)
+# 	   SUBDIRS(app_test)
+# 	ENDIF (BUILD_APP_TEST)
Index: extensions/_sample/CMakeLists.txt
===================================================================
--- extensions/_sample/CMakeLists.txt	(revision 8)
+++ extensions/_sample/CMakeLists.txt	(revision 8)
@@ -0,0 +1,9 @@
+# The sample extension
+PROJECT("Sample extension" C)
+
+# Compile as a module
+ADD_LIBRARY(sample MODULE sample.c fini.c)
+
+# Comply to naming scheme
+SET_TARGET_PROPERTIES(sample PROPERTIES PREFIX "${FD_EXT_PREFIX}" )
+SET_TARGET_PROPERTIES(sample PROPERTIES SUFFIX "${FD_EXT_SUFFIX}" )
Index: extensions/_sample/fini.c
===================================================================
--- extensions/_sample/fini.c	(revision 8)
+++ extensions/_sample/fini.c	(revision 8)
@@ -0,0 +1,45 @@
+/*********************************************************************************************************
+* Software License Agreement (BSD License)                                                               *
+* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
+*													 *
+* Copyright (c) 2008, WIDE Project and NICT								 *
+* All rights reserved.											 *
+* 													 *
+* Redistribution and use of this software in source and binary forms, with or without modification, are  *
+* permitted provided that the following conditions are met:						 *
+* 													 *
+* * Redistributions of source code must retain the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer.										 *
+*    													 *
+* * Redistributions in binary form must reproduce the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer in the documentation and/or other						 *
+*   materials provided with the distribution.								 *
+* 													 *
+* * Neither the name of the WIDE Project or NICT nor the 						 *
+*   names of its contributors may be used to endorse or 						 *
+*   promote products derived from this software without 						 *
+*   specific prior written permission of WIDE Project and 						 *
+*   NICT.												 *
+* 													 *
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
+* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
+* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
+* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
+* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
+* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
+* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
+*********************************************************************************************************/
+
+/* Sample extension exit point */
+
+#include <freeDiameter/extension.h>
+
+void fd_ext_fini(void)
+{
+	log_debug("Extension is terminated... Bye!\n");
+	return ;
+}
+
Index: extensions/_sample/sample.c
===================================================================
--- extensions/_sample/sample.c	(revision 8)
+++ extensions/_sample/sample.c	(revision 8)
@@ -0,0 +1,84 @@
+/*********************************************************************************************************
+* Software License Agreement (BSD License)                                                               *
+* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
+*													 *
+* Copyright (c) 2009, WIDE Project and NICT								 *
+* All rights reserved.											 *
+* 													 *
+* Redistribution and use of this software in source and binary forms, with or without modification, are  *
+* permitted provided that the following conditions are met:						 *
+* 													 *
+* * Redistributions of source code must retain the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer.										 *
+*    													 *
+* * Redistributions in binary form must reproduce the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer in the documentation and/or other						 *
+*   materials provided with the distribution.								 *
+* 													 *
+* * Neither the name of the WIDE Project or NICT nor the 						 *
+*   names of its contributors may be used to endorse or 						 *
+*   promote products derived from this software without 						 *
+*   specific prior written permission of WIDE Project and 						 *
+*   NICT.												 *
+* 													 *
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
+* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
+* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
+* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
+* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
+* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
+* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
+*********************************************************************************************************/
+
+/* Sample extension to test extensions mechanism in freeDiameter */
+#include <freeDiameter/extension.h>
+
+static int sample_main(char * conffile);
+
+/* Define the entry point. A convenience macro is provided */
+EXTENSION_ENTRY("sample", sample_main);
+
+/* The extension-specific initialization code */
+static int sample_main(char * conffile)
+{
+	TRACE_ENTRY("%p", conffile);
+	
+	fprintf(stdout, "I am extension " __FILE__ " running on host %s\n", fd_g_config->diam_id);
+	
+	if (conffile) {
+		fprintf(stdout, "I should parse my configuration file there: %s\n", conffile);
+	} else {
+		fprintf(stdout, "I received no configuration file to parse\n");
+	}
+	
+	/* Use the dictionary for test */
+	log_debug("Let's create that 'Example-AVP'...\n");
+	{
+		struct dict_object * origin_host_avp = NULL;
+		struct dict_object * session_id_avp = NULL;
+		struct dict_object * example_avp_avp = NULL;
+		struct dict_rule_data rule_data = { NULL, RULE_REQUIRED, 0, -1, 1 };
+		struct dict_avp_data example_avp_data = { 999999, 0, "Example-AVP", AVP_FLAG_VENDOR , 0, AVP_TYPE_GROUPED };
+
+		CHECK_FCT( fd_dict_search ( fd_g_config->g_dict, DICT_AVP, AVP_BY_NAME, "Origin-Host", &origin_host_avp, ENOENT));
+		CHECK_FCT( fd_dict_search ( fd_g_config->g_dict, DICT_AVP, AVP_BY_NAME, "Session-Id", &session_id_avp, ENOENT));
+		
+		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_AVP, &example_avp_data , NULL, &example_avp_avp ));
+		
+		rule_data.rule_avp = origin_host_avp;
+		rule_data.rule_min = 1;
+		rule_data.rule_max = 1;
+		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
+		
+		rule_data.rule_avp = session_id_avp;
+		rule_data.rule_min = 1;
+		rule_data.rule_max = -1;
+		CHECK_FCT( fd_dict_new ( fd_g_config->g_dict, DICT_RULE, &rule_data, example_avp_avp, NULL ));
+	}
+	log_debug("'Example-AVP' created without error\n");
+	
+	return 0;
+}
Index: freeDiameter/CMakeLists.txt
===================================================================
--- freeDiameter/CMakeLists.txt	(revision 2)
+++ freeDiameter/CMakeLists.txt	(revision 8)
@@ -2,15 +2,26 @@
 Project("freeDiameterd" C)
 
-SET(PROJECT_VERSION 0.1)
-SET(PROJECT_COPYRIGHT "Copyright (c) 2008-2009, WIDE Project (www.wide.ad.jp) and NICT (www.nict.go.jp)")
+# Configuration parser
+BISON_FILE(fdd.y)
+FLEX_FILE(fdd.l)
+SET_SOURCE_FILES_PROPERTIES(lex.fdd.c fdd.tab.c PROPERTIES COMPILE_FLAGS "-I ${CMAKE_CURRENT_SOURCE_DIR}")
 
 # List of source files
 SET(FD_COMMON_SRC
 	fD.h
+	config.c
+	extensions.c
 	dict_base_proto.c
 	)
 
+SET(FD_COMMON_GEN_SRC
+		lex.fdd.c
+		fdd.tab.c
+		fdd.tab.h
+	)
+
+
 # Building the executable
-ADD_EXECUTABLE(freeDiameterd ${FD_COMMON_SRC} main.c)
+ADD_EXECUTABLE(freeDiameterd ${FD_COMMON_SRC} ${FD_COMMON_GEN_SRC} main.c)
 
 # The link command
@@ -20,4 +31,5 @@
 # Save the list of files, if needed
 SET(FD_COMMON_SRC ${FD_COMMON_SRC} PARENT_SCOPE)
+SET(FD_COMMON_GEN_SRC ${FD_COMMON_GEN_SRC} PARENT_SCOPE)
 
 # The unary tests directory
Index: freeDiameter/config.c
===================================================================
--- freeDiameter/config.c	(revision 8)
+++ freeDiameter/config.c	(revision 8)
@@ -0,0 +1,189 @@
+/*********************************************************************************************************
+* Software License Agreement (BSD License)                                                               *
+* Author: Sebastien Decugis <sdecugis@nict.go.jp>							 *
+*													 *
+* Copyright (c) 2009, WIDE Project and NICT								 *
+* All rights reserved.											 *
+* 													 *
+* Redistribution and use of this software in source and binary forms, with or without modification, are  *
+* permitted provided that the following conditions are met:						 *
+* 													 *
+* * Redistributions of source code must retain the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer.										 *
+*    													 *
+* * Redistributions in binary form must reproduce the above 						 *
+*   copyright notice, this list of conditions and the 							 *
+*   following disclaimer in the documentation and/or other						 *
+*   materials provided with the distribution.								 *
+* 													 *
+* * Neither the name of the WIDE Project or NICT nor the 						 *
+*   names of its contributors may be used to endorse or 						 *
+*   promote products derived from this software without 						 *
+*   specific prior written permission of WIDE Project and 						 *
+*   NICT.												 *
+* 													 *
+* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED *
+* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
+* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR *
+* ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 	 *
+* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 	 *
+* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR *
+* TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF   *
+* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.								 *
+*********************************************************************************************************/
+
+#include "fD.h"
+
+/* Configuration management */
+
+/* Initialize the fd_g_config structure to default values */
+int fd_conf_init()
+{
+	TRACE_ENTRY();
+	
+	fd_g_config->eyec = EYEC_CONFIG;
+	fd_g_config->conf_file = DEFAULT_CONF_FILE;
+	
+	fd_g_config->loc_port     = 3868;
+	fd_g_config->loc_port_tls = 3869;
+	fd_g_config->loc_sctp_str = 30;
+	fd_list_init(&fd_g_config->loc_endpoints, NULL);
+	
+	#ifdef DISABLE_SCTP
+	fd_g_config->flags.no_sctp = 1;
+	#endif /* DISABLE_SCTP */
+	
+	fd_g_config->timer_tc = 30;
+	fd_g_config->timer_tw = 30;
+	
+	fd_g_config->or_state_id = (uint32_t) time(NULL);
+	
+	CHECK_FCT( fd_dict_init(&fd_g_config->g_dict) );
+	CHECK_FCT( fd_fifo_new(&fd_g_config->g_fifo_main) );
+	
+	return 0;
+}
+
+void fd_conf_dump()
+{
+	if (!TRACE_BOOL(INFO))
+		return;
+	
+	fd_log_debug("-- Configuration :\n");
+	fd_log_debug("  Debug trace level ...... : %+d\n", fd_g_debug_lvl);
+	fd_log_debug("  Configuration file ..... : %s\n", fd_g_config->conf_file);
+	fd_log_debug("  Diameter Identity ...... : %s (l:%Zi)\n", fd_g_config->diam_id, fd_g_config->diam_id_len);
+	fd_log_debug("  Diameter Realm ......... : %s (l:%Zi)\n", fd_g_config->diam_realm, fd_g_config->diam_realm_len);
+	fd_log_debug("  Local port ............. : %hu\n", fd_g_config->loc_port);
+	fd_log_debug("  Local secure port ...... : %hu\n", fd_g_config->loc_port_tls);
+	fd_log_debug("  Number of SCTP streams . : %hu\n", fd_g_config->loc_sctp_str);
+	if (FD_IS_LIST_EMPTY(&fd_g_config->loc_endpoints)) {
+		fd_log_debug("  Local endpoints ........ : Default (use all available)\n");
+	} else {
+		struct fd_list * li = fd_g_config->loc_endpoints.next;
+		fd_log_debug("  Local endpoints ........ : ");
+		while (li != &fd_g_config->loc_endpoints) {
+			struct fd_endpoint * ep = (struct fd_endpoint *)li;
+			if (li != fd_g_config->loc_endpoints.next) fd_log_debug("                             ");
+			sSA_DUMP_NODE( &ep->ss, NI_NUMERICHOST );
+			fd_log_debug("\n");
+			li = li->next;
+		}
+	}
+	fd_log_debug("  Flags : - IP ........... : %s\n", fd_g_config->flags.no_ip4 ? "DISABLED" : "Enabled");
+	fd_log_debug("          - IPv6 ......... : %s\n", fd_g_config->flags.no_ip6 ? "DISABLED" : "Enabled");
+	fd_log_debug("          - Relay app .... : %s\n", fd_g_config->flags.no_fwd ? "DISABLED" : "Enabled");
+	fd_log_debug("          - TCP .......... : %s\n", fd_g_config->flags.no_tcp ? "DISABLED" : "Enabled");
+	#ifdef DISABLE_SCTP
+	fd_log_debug("          - SCTP ......... : DISABLED (at compilation)\n");
+	#else /* DISABLE_SCTP */
+	fd_log_debug("          - SCTP ......... : %s\n", fd_g_config->flags.no_sctp ? "DISABLED" : "Enabled");
+	#endif /* DISABLE_SCTP */
+	fd_log_debug("          - Pref. proto .. : %s\n", fd_g_config->flags.pr_tcp ? "TCP" : "SCTP");
+	fd_log_debug("          - TLS method ... : %s\n", fd_g_config->flags.tls_alg ? "INBAND" : "Separate port");
+	fd_log_debug("  Tc Timer ............... : %u\n", fd_g_config->timer_tc);
+	fd_log_debug("  Tw Timer ............... : %u\n", fd_g_config->timer_tw);
+	fd_log_debug("  Origin-State-Id ........ : %u\n", fd_g_config->or_state_id);
+}
+
+/* Parse the configuration file (using the yacc parser) */
+int fd_conf_parse()
+{
+	extern FILE * fddin;
+	
+	TRACE_DEBUG (FULL, "Parsing configuration file: %s", fd_g_config->conf_file);
+	
+	fddin = fopen(fd_g_config->conf_file, "r");
+	if (fddin == NULL) {
+		int ret = errno;
+		fprintf(stderr, "Unable to open configuration file %s for reading: %s\n", fd_g_config->conf_file, strerror(ret));
+		return ret;
+	}
+	
+	/* call yacc parser */
+	CHECK_FCT(  fddparse(fd_g_config)  );
+	
+	/* close the file */
+	fclose(fddin);
+	
+	/* Resolve hostname if not provided */
+	if (fd_g_config->diam_id == NULL) {
+#ifndef HOST_NAME_MAX
+#define HOST_NAME_MAX 1024
+#endif /* HOST_NAME_MAX */
+		char buf[HOST_NAME_MAX + 1];
+		struct addrinfo hints, *info;
+		int ret;
+		
+		/* local host name */
+		CHECK_SYS(gethostname(buf, sizeof(buf)));
+		
+		/* get FQDN */
+		memset(&hints, 0, sizeof hints);
+		hints.ai_flags = AI_CANONNAME;
+
+		ret = getaddrinfo(buf, NULL, &hints, &info);
+		if (ret != 0) {
+			fprintf(stderr, "Error resolving local FQDN :\n"
+					" '%s' : %s\n"
+					"Please provide LocalIdentity in configuration file.\n",
+					buf, gai_strerror(ret));
+			return EINVAL;
+		}
+		CHECK_MALLOC( fd_g_config->diam_id = strdup(info->ai_canonname) );
+		freeaddrinfo(info);
+	}
+	
+	/* cache the length of the diameter id for the session module */
+	fd_g_config->diam_id_len = strlen(fd_g_config->diam_id);
+	
+	/* Handle the realm part */
+	if (fd_g_config->diam_realm == NULL) {
+		char * start = NULL;
+		
+		/* Check the diameter identity is a fqdn */
+		start = strchr(fd_g_config->diam_id, '.');
+		if ((start == NULL) || (start[1] == '\0')) {
+			fprintf(stderr, "Unable to extract realm from the LocalIdentity '%s'.\n"
+					"Please fix your LocalIdentity setting or provide LocalRealm.\n",
+					fd_g_config->diam_id);
+			return EINVAL;
+		}		
+		
+		CHECK_MALLOC( fd_g_config->diam_realm = strdup( start + 1 )  ); 
+	}
+	fd_g_config->diam_realm_len = strlen(fd_g_config->diam_realm);
+	
+	/* Validate some flags */
+	if (fd_g_config->flags.no_ip4 && fd_g_config->flags.no_ip6) {
+		fprintf(stderr, "IP and IPv6 cannot be disabled at the same time.\n");
+		return EINVAL;
+	}
+	if (fd_g_config->flags.no_tcp && fd_g_config->flags.no_sctp) {
+		fprintf(stderr, "TCP and SCTP cannot be disabled at the same time.\n");
+		return EINVAL;
+	}
+	
+	return 0;
+}
